<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ServerCnxnFactory.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">ServerCnxnFactory.java</span></div><h1>ServerCnxnFactory.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.util.HashSet;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import javax.security.auth.login.Configuration;
import javax.security.auth.login.LoginException;
import javax.security.auth.login.AppConfigurationEntry;

import javax.management.JMException;

import org.apache.zookeeper.Login;
import org.apache.zookeeper.Environment;
import org.apache.zookeeper.jmx.MBeanRegistry;
import org.apache.zookeeper.server.auth.SaslServerCallbackHandler;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

<span class="fc" id="L41">public abstract class ServerCnxnFactory {</span>

    public static final String ZOOKEEPER_SERVER_CNXN_FACTORY = &quot;zookeeper.serverCnxnFactory&quot;;

    public interface PacketProcessor {
        public void processPacket(ByteBuffer packet, ServerCnxn src);
    }
    
<span class="fc" id="L49">    Logger LOG = LoggerFactory.getLogger(ServerCnxnFactory.class);</span>

    /**
     * The buffer will cause the connection to be close when we do a send.
     */
<span class="fc" id="L54">    static final ByteBuffer closeConn = ByteBuffer.allocate(0);</span>

    public abstract int getLocalPort();
    
    public abstract Iterable&lt;ServerCnxn&gt; getConnections();

    public int getNumAliveConnections() {
<span class="fc" id="L61">        synchronized(cnxns) {</span>
<span class="fc" id="L62">            return cnxns.size();</span>
<span class="nc" id="L63">        }</span>
    }

    public abstract void closeSession(long sessionId);

    public abstract void configure(InetSocketAddress addr,
                                   int maxClientCnxns) throws IOException;

    protected SaslServerCallbackHandler saslServerCallbackHandler;
    public Login login;

    /** Maximum number of connections allowed from particular host (ip) */
    public abstract int getMaxClientCnxnsPerHost();

    /** Maximum number of connections allowed from particular host (ip) */
    public abstract void setMaxClientCnxnsPerHost(int max);

    public abstract void startup(ZooKeeperServer zkServer)
        throws IOException, InterruptedException;

    public abstract void join() throws InterruptedException;

    public abstract void shutdown();

    public abstract void start();

    protected ZooKeeperServer zkServer;
    final public void setZooKeeperServer(ZooKeeperServer zk) {
<span class="fc" id="L91">        this.zkServer = zk;</span>
<span class="fc bfc" id="L92" title="All 2 branches covered.">        if (zk != null) {</span>
<span class="fc" id="L93">            zk.setServerCnxnFactory(this);</span>
        }
<span class="fc" id="L95">    }</span>

    public abstract void closeAll();
    
    static public ServerCnxnFactory createFactory() throws IOException {
<span class="fc" id="L100">        String serverCnxnFactoryName =</span>
<span class="fc" id="L101">            System.getProperty(ZOOKEEPER_SERVER_CNXN_FACTORY);</span>
<span class="fc bfc" id="L102" title="All 2 branches covered.">        if (serverCnxnFactoryName == null) {</span>
<span class="fc" id="L103">            serverCnxnFactoryName = NIOServerCnxnFactory.class.getName();</span>
        }
        try {
<span class="fc" id="L106">            return (ServerCnxnFactory) Class.forName(serverCnxnFactoryName)</span>
<span class="fc" id="L107">                                                .newInstance();</span>
<span class="nc" id="L108">        } catch (Exception e) {</span>
<span class="nc" id="L109">            IOException ioe = new IOException(&quot;Couldn't instantiate &quot;</span>
                    + serverCnxnFactoryName);
<span class="nc" id="L111">            ioe.initCause(e);</span>
<span class="nc" id="L112">            throw ioe;</span>
        }
    }
    
    static public ServerCnxnFactory createFactory(int clientPort,
            int maxClientCnxns) throws IOException
    {
<span class="fc" id="L119">        return createFactory(new InetSocketAddress(clientPort), maxClientCnxns);</span>
    }

    static public ServerCnxnFactory createFactory(InetSocketAddress addr,
            int maxClientCnxns) throws IOException
    {
<span class="fc" id="L125">        ServerCnxnFactory factory = createFactory();</span>
<span class="fc" id="L126">        factory.configure(addr, maxClientCnxns);</span>
<span class="fc" id="L127">        return factory;</span>
    }

    public abstract InetSocketAddress getLocalAddress();

<span class="fc" id="L132">    private final Map&lt;ServerCnxn, ConnectionBean&gt; connectionBeans</span>
        = new ConcurrentHashMap&lt;ServerCnxn, ConnectionBean&gt;();

<span class="fc" id="L135">    protected final HashSet&lt;ServerCnxn&gt; cnxns = new HashSet&lt;ServerCnxn&gt;();</span>
    public void unregisterConnection(ServerCnxn serverCnxn) {
<span class="fc" id="L137">        ConnectionBean jmxConnectionBean = connectionBeans.remove(serverCnxn);</span>
<span class="fc bfc" id="L138" title="All 2 branches covered.">        if (jmxConnectionBean != null){</span>
<span class="fc" id="L139">            MBeanRegistry.getInstance().unregister(jmxConnectionBean);</span>
        }
<span class="fc" id="L141">    }</span>
    
    public void registerConnection(ServerCnxn serverCnxn) {
<span class="pc bpc" id="L144" title="1 of 2 branches missed.">        if (zkServer != null) {</span>
<span class="fc" id="L145">            ConnectionBean jmxConnectionBean = new ConnectionBean(serverCnxn, zkServer);</span>
            try {
<span class="fc" id="L147">                MBeanRegistry.getInstance().register(jmxConnectionBean, zkServer.jmxServerBean);</span>
<span class="fc" id="L148">                connectionBeans.put(serverCnxn, jmxConnectionBean);</span>
<span class="nc" id="L149">            } catch (JMException e) {</span>
<span class="nc" id="L150">                LOG.warn(&quot;Could not register connection&quot;, e);</span>
<span class="fc" id="L151">            }</span>
        }

<span class="fc" id="L154">    }</span>

    /**
     * Initialize the server SASL if specified.
     *
     * If the user has specified a &quot;ZooKeeperServer.LOGIN_CONTEXT_NAME_KEY&quot;
     * or a jaas.conf using &quot;java.security.auth.login.config&quot;
     * the authentication is required and an exception is raised.
     * Otherwise no authentication is configured and no exception is raised.
     *
     * @throws IOException if jaas.conf is missing or there's an error in it.
     */
    protected void configureSaslLogin() throws IOException {
<span class="fc" id="L167">        String serverSection = System.getProperty(ZooKeeperSaslServer.LOGIN_CONTEXT_NAME_KEY,</span>
                                                  ZooKeeperSaslServer.DEFAULT_LOGIN_CONTEXT_NAME);

        // Note that 'Configuration' here refers to javax.security.auth.login.Configuration.
<span class="fc" id="L171">        AppConfigurationEntry entries[] = null;</span>
<span class="fc" id="L172">        SecurityException securityException = null;</span>
        try {
<span class="fc" id="L174">            entries = Configuration.getConfiguration().getAppConfigurationEntry(serverSection);</span>
<span class="nc" id="L175">        } catch (SecurityException e) {</span>
            // handle below: might be harmless if the user doesn't intend to use JAAS authentication.
<span class="nc" id="L177">            securityException = e;</span>
<span class="fc" id="L178">        }</span>

        // No entries in jaas.conf
        // If there's a configuration exception fetching the jaas section and
        // the user has required sasl by specifying a LOGIN_CONTEXT_NAME_KEY or a jaas file
        // we throw an exception otherwise we continue without authentication.
<span class="fc bfc" id="L184" title="All 2 branches covered.">        if (entries == null) {</span>
<span class="fc" id="L185">            String jaasFile = System.getProperty(Environment.JAAS_CONF_KEY);</span>
<span class="fc" id="L186">            String loginContextName = System.getProperty(ZooKeeperSaslServer.LOGIN_CONTEXT_NAME_KEY);</span>
<span class="pc bpc" id="L187" title="5 of 6 branches missed.">            if (securityException != null &amp;&amp; (loginContextName != null || jaasFile != null)) {</span>
<span class="nc" id="L188">                String errorMessage = &quot;No JAAS configuration section named '&quot; + serverSection +  &quot;' was found&quot;;</span>
<span class="nc bnc" id="L189" title="All 2 branches missed.">                if (jaasFile != null) {</span>
<span class="nc" id="L190">                    errorMessage += &quot;in '&quot; + jaasFile + &quot;'.&quot;;</span>
                }
<span class="nc bnc" id="L192" title="All 2 branches missed.">                if (loginContextName != null) {</span>
<span class="nc" id="L193">                    errorMessage += &quot; But &quot; + ZooKeeperSaslServer.LOGIN_CONTEXT_NAME_KEY + &quot; was set.&quot;;</span>
                }
<span class="nc" id="L195">                LOG.error(errorMessage);</span>
<span class="nc" id="L196">                throw new IOException(errorMessage);</span>
            }
<span class="fc" id="L198">            return;</span>
        }

        // jaas.conf entry available
        try {
<span class="fc" id="L203">            saslServerCallbackHandler = new SaslServerCallbackHandler(Configuration.getConfiguration());</span>
<span class="fc" id="L204">            login = new Login(serverSection, saslServerCallbackHandler);</span>
<span class="fc" id="L205">            login.startThreadIfNeeded();</span>
<span class="nc" id="L206">        } catch (LoginException e) {</span>
<span class="nc" id="L207">            throw new IOException(&quot;Could not configure server because SASL configuration did not allow the &quot;</span>
              + &quot; ZooKeeper server to authenticate itself properly: &quot; + e);
<span class="fc" id="L209">        }</span>
<span class="fc" id="L210">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>